<?php
/*
Plugin Name: G&ouml;SPress
Plugin URI: http://www.michael-gerard.com/creations/goospress
Description: G&ouml;SPress is a spellcheck plug-in for WordPress built around <a href="http://orangoo.com/labs/GoogieSpell/">Googie Spell</a> developed by <a href="http://amix.dk/">Amir Salihefendic</a>. G&ouml;SPress delivers spellcheck to those who prefer not to use the Visual Editor, along with the ability to allow spellcheck for reader commenting.
Version: 2.1a r004
Author: Michael Gerard
Author URI: http://www.michael-gerard.com
Tags: google, google+spell, spelling, spellcheck, spell+check, WordPress+Plugins, blogging 
*/

/*
    GooSPress Copyright 2007 Michael Gerard Fitzpatrick
    GoogieSpell Copyright 2006 Amir Salihefendic
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*

	CREDITS
	
	Powered by:	Google Spell Check
	
	Built on:	GoogieSpell (http://orangoo.com/labs/GoogieSpell)  Copyright 2006 Amir Salihefendic (http://amix.dk)

*/		

/*
	CHANGE LOG
	2.1a r004 (05 MAY 2007)
	- ETC ETC - No more tags in svn. Changed the update dl link to point to the wp.org.

	2.1a r003 (05 MAY 2007)
	- BUG FIX - Changed directory name from 'wp-goospress' to 'goospress' since that is the folder created when unzipping the download from the Wordpress site.

	2.1a r002 (04 MAY 2007)
	- BUG FIX - Comment form spell checker now abides by language rules set in options panel.
	- ETC ETC - I fixed numerous spelling errors randomly strewn throughout.

	2.1a r001 (01 MAY 2007)
	- Initial Alpha Release -- ONLY TESTED WITH WORDPRESS 2.1
	- The Spell Check in WP's Visual Editor takes precedence over this plug-in... Thus, if you use the Visual Editor, it ain't for you!
	- More CSS work to be done such that it "looks nicer" on the page... The "streamlined" AJS.js library isn't making it any easier :P

	
*/


// DECLARE VARIABLES //

// VERSION
$goosp_ver = "2.1a r004";
// VERSION CHECK
$goosp_localversion = "2104";

// URL
$awext_url = "goospress/wp_goospress.php";

// FUNCTION TO LOAD AWSTATS MISC TRACKER
class goosp_injection {

	// GOOSP HEADER JS
	function goosp_header() {
	
		// LOAD GLOBALS
		global $goosp_ver;
		global $goosp_url;
		
		// ADD SCRIPT TO WP HEADER
		echo '
			<!-- ADDED BY GooSPress PLUGIN VERSION '.$goosp_ver.' -->
			<link href="'.get_bloginfo("wpurl").'/wp-content/plugins/goospress/googiespell/googiespell.css" rel="stylesheet" type="text/css" media="all" />
			<script type="text/javascript" src="'.get_bloginfo("wpurl").'/wp-content/plugins/goospress/googiespell/AJS.js"></script>
			<script type="text/javascript" src="'.get_bloginfo("wpurl").'/wp-content/plugins/goospress/googiespell/googiespell.js"></script>
			<script type="text/javascript" src="'.get_bloginfo("wpurl").'/wp-content/plugins/goospress/googiespell/cookiesupport.js"></script>
			<!-- END GooSPress PLUGIN VERSION '.$goosp_ver.' -->
			';

	}
	
	// GOOSP ADMIN EDITOR TOOLKIT
	function goosp_admin_toolkit() {

		// LOAD GLOBALS
		global $goosp_ver;
		global $goosp_url;
		
		// BUILD LANGUAGES MENU
		$goosp_lang_build = get_option('goosp_lang_code');
		$goosp_lang_array = array();
		
		foreach($goosp_lang_build as $goosp_value){
			if($goosp_value != ""){ 
				$goosp_lang_array[] = $goosp_value; 
			}
		}
		
		$goosp_comma_sep = implode(",", $goosp_lang_array);
	
		$goosp_lang_menu = 'goospress.setLanguages({'.$goosp_comma_sep.'});';
		
		// ADD SCRIPT TO POST / PAGE EDITORS
		echo '
			<!-- ADDED BY GooSPress PLUGIN VERSION '.$goosp_ver.' -->	
			<script type="text/javascript">
			var goospress = new GoogieSpell("'.get_bloginfo("wpurl").'/wp-content/plugins/goospress/googiespell/", "'.get_bloginfo("wpurl").'/wp-content/plugins/goospress/googiespell/sendReq.php?lang=");
			goospress.decorateTextarea("content");'.$goosp_lang_menu.'';
		if(get_option('goosp_disp_clos') == false){
			echo 'goospress.dontUseCloseButtons();';
		}
		echo '
			</script>
			<!-- END GooSPress PLUGIN VERSION '.$goosp_ver.' -->
			';

	}
	
	// GOOSP COMMENT EDITOR TOOLKIT
	function goosp_cmmnt_toolkit() {
	
		// LOAD GLOBALS
		global $goosp_ver;
		global $goosp_url;
		
		// BUILD LANGUAGES MENU
		$goosp_lang_build = get_option('goosp_lang_code');
		$goosp_lang_array = array();
		
		foreach($goosp_lang_build as $goosp_value){
			if($goosp_value != ""){ 
				$goosp_lang_array[] = $goosp_value; 
			}
		}
		
		$goosp_comma_sep = implode(",", $goosp_lang_array);
	
		$goosp_lang_menu = 'goospress.setLanguages({'.$goosp_comma_sep.'});';
	
		// ADD SCRIPT TO COMMENTS FORM
		echo '
			<!-- ADDED BY GooSPress PLUGIN VERSION '.$goosp_ver.' -->	
			<script type="text/javascript">
			var goospress = new GoogieSpell("'.get_bloginfo("wpurl").'/wp-content/plugins/goospress/googiespell/", "'.get_bloginfo("wpurl").'/wp-content/plugins/goospress/googiespell/sendReq.php?lang=");
			goospress.decorateTextarea("comment");'.$goosp_lang_menu.'';
		if(get_option('goosp_disp_clos') == false){
			echo 'goospress.dontUseCloseButtons();';
		}
		echo '
			</script>
			<!-- END GooSPress PLUGIN VERSION '.$goosp_ver.' -->
			';
	
	}


	
}

// INSTALLER CLASS (HANDLES INSTALL/UNINSTALL)
class goosp_installer {

	// INSTALL //
	function activate() {

		// Insertion Options
		update_option('goosp_edit_post', '1', 'Add Spell Check to Post Editor');
		update_option('goosp_edit_page', '1', 'Add Spell Check to Page Editor');
		update_option('goosp_edit_cmnt', '1', 'Add Spell Check to Comment Editor');
		
		// Language Options
		update_option('goosp_lang_chkb', array('da_check' => '1', 'de_check' => '1', 'en_check' => '1', 'es_check' => '1', 'fr_check' => '1', 'it_check' => '1', 'nl_check' => '1', 'pl_check' => '1', 'pt_check' => '1', 'fi_check' => '1', 'de_check' => '1'), 'Languages to display in Spellcheck menu');

		$chkb = get_option('goosp_lang_chkb');
		if($chkb['da_check'] == false){ $da = ""; }else{ $da = "'da': 'Dansk'"; }
		if($chkb['de_check'] == false){ $de = ""; }else{ $de = "'de': 'Deutsch'"; }
		if($chkb['en_check'] == false){ $en = ""; }else{ $en = "'en': 'English'"; }
		if($chkb['es_check'] == false){ $es = ""; }else{ $es = "'es': 'Espa&#241;ol'"; }
		if($chkb['fr_check'] == false){ $fr = ""; }else{ $fr = "'fr': 'Fran&#231;ais'"; }
		if($chkb['it_check'] == false){ $it = ""; }else{ $it = "'it': 'Italiano'"; }
		if($chkb['nl_check'] == false){ $nl = ""; }else{ $nl = "'nl': 'Nederlands'"; }
		if($chkb['pl_check'] == false){ $pl = ""; }else{ $pl = "'pl': 'Polski'"; }
		if($chkb['pt_check'] == false){ $pt = ""; }else{ $pt = "'pt': 'Portugu&#234;s'"; }
		if($chkb['fi_check'] == false){ $fi = ""; }else{ $fi = "'fi': 'Suomi'"; }
		if($chkb['sv_check'] == false){ $sv = ""; }else{ $sv = "'sv': 'Svenska'"; }
		update_option('goosp_lang_code', array('da' => $da, 'de' => $de, 'en' => $en, 'es' => $es, 'fr' => $fr, 'it' => $it, 'nl' => $nl, 'pl' => $pl, 'pt' => $pt, 'fi' => $fi, 'sv' => $sv), 'Code for languages popup');
		
		// Display Options
		update_option('goosp_disp_clos', '1', 'Display Close Button on Spell Check Pop-ups');

	}

	// UNINSTALL //
	function deactivate() {

		// Insertion Options
		delete_option('goosp_edit_post');
		delete_option('goosp_edit_page');
		delete_option('goosp_edit_cmnt');
		
		// Language Options
		delete_option('goosp_lang_chkb');
		delete_option('goosp_lang_code');
		
		// Display Options
		delete_option('goosp_disp_clos');

	}
	
}


// ADMINISTRATION PANEL
 function goosp_options_subpanel() {

	// LOAD GLOBALS
	global $goosp_ver;
	global $goosp_url;


	// GET and COMPARE RENMOTE VERSION
	function goosp_remote_vcheck() {
		
		include_once(ABSPATH . WPINC . '/class-snoopy.php');
		$goosp_remoteversion = 'http://www.michael-gerard.com/wp-content/downloads/goospress/vcheck/goospress-version.txt';
	
		global $goosp_localversion;
	
		if (class_exists(snoopy)) {
			$client = new Snoopy();
			$client->_fp_timeout = 4;
			if (@$client->fetch($goosp_remoteversion) === false) {
				return -1;
			}
			$remote = $client->results;
			if (!$remote || strlen($remote) > 8 ) {
				return -1;
			} 
			if (intval($remote) > intval($goosp_localversion)) {
				return 1;
			} else {
				return 0;
			}
		}
		
	}

	// IS FORM BEING SUBMITTED
	if (isset($_POST['submitted'])) {

		// Get form data
		$goosp_edit_post = $_POST['goosp_edit_post'];
		$goosp_edit_page = $_POST['goosp_edit_page'];
		$goosp_edit_cmnt = $_POST['goosp_edit_cmnt'];

		$goosp_lang_chkb = array('da_check' => $_POST['da_check'], 'de_check' => $_POST['de_check'], 'en_check' => $_POST['en_check'],
								'es_check' => $_POST['es_check'], 'fr_check' => $_POST['fr_check'], 'it_check' => $_POST['it_check'],
								'nl_check' => $_POST['nl_check'], 'pl_check' => $_POST['pl_check'], 'pt_check' => $_POST['pt_check'],
								'fi_check' => $_POST['fi_check'], 'sv_check' => $_POST['sv_check']);

		if($_POST["da_check"] == false){ $da = ''; }elseif($_POST["da_check"] == '1'){ $da = '"da": "Dansk"'; }
		if($_POST["de_check"] == false){ $da = ''; }else{ $de = '"de": "Deutsch"'; }
		if($_POST["en_check"] == false){ $da = ''; }else{ $en = '"en": "English"'; }
		if($_POST["es_check"] == false){ $da = ''; }else{ $es = '"es": "Espa&#241;ol"'; }
		if($_POST["fr_check"] == false){ $da = ''; }else{ $fr = '"fr": "Fran&#231;ais"'; }
		if($_POST["it_check"] == false){ $da = ''; }else{ $it = '"it": "Italiano"'; }
		if($_POST["nl_check"] == false){ $da = ''; }else{ $nl = '"nl": "Nederlands"'; }
		if($_POST["pl_check"] == false){ $da = ''; }else{ $pl = '"pl": "Polski"'; }
		if($_POST["pt_check"] == false){ $da = ''; }else{ $pt = '"pt": "Portugu&#234;s"'; }
		if($_POST["fi_check"] == false){ $da = ''; }else{ $fi = '"fi": "Suomi"'; }
		if($_POST["sv_check"] == false){ $da = ''; }else{ $sv = '"sv": "Svenska"'; }

		$goosp_lang_code = array('da' => $da, 'de' => $de, 'en' => $en, 'es' => $es, 'fr' => $fr, 'it' => $it,
								'nl' => $nl, 'pl' => $pl, 'pt' => $pt, 'fi' => $fi, 'sv' => $sv);

		$goosp_disp_clos = $_POST['goosp_disp_clos'];


		// Update Options
		update_option('goosp_edit_post', $goosp_edit_post);
		update_option('goosp_edit_page', $goosp_edit_page);
		update_option('goosp_edit_cmnt', $goosp_edit_cmnt);

		update_option('goosp_lang_chkb', $goosp_lang_chkb);
		update_option('goosp_lang_code', $goosp_lang_code);

		update_option('goosp_disp_clos', $goosp_disp_clos);
		
		?> 

		<!-- Echo Options Updated -->
		<div id="message" class="updated fade"><p><b>G&ouml;SPress options updated!</b></p></div> 

<?php } ?>

	<div class="wrap">
		<h2>G&ouml;SPress<span style="float:right;"><i>GoogieSpell modified for WordPress</i></span></h2>
		<p><b>Version:</b> <?php echo $goosp_ver; ?>
		<!-- Version Check -->
		<?php if(goosp_remote_vcheck() == 0){ ?>
			<span style="color:green;">You have the most current version of G&ouml;SPress</span></p>
		<?php }elseif(goosp_remote_vcheck() == 1){
			if (class_exists(snoopy)) {
				$goosp_remote_v_nice =  'http://www.michael-gerard.com/wp-content/downloads/goospress/vcheck/goospress-vnice.txt';
				$client = new Snoopy();
				$client->_fp_timeout = 4;
				if (@$client->fetch($goosp_remote_v_nice) === false) {
					break;
				}else{
				$remote = $client->results;
					$goosp_new_version = $remote;
				}
			} ?>
			<b><span style="color:red;">There is a new version (<?php echo $goosp_new_version; ?>) of G&ouml;SPress available. <a href="http://downloads.wordpress.org/plugin/goospress.zip">Download Now</a></span></b></p>
		<?php }else{ ?>
			<span style="color:red;">Version checking unavailable. Please visit <a href="http://www.michael-gerard.com/creations/goospress/">Tossed Salad</a> to check for available updates.</span></p>
		<?php } ?>	

			<form method="post" name="options" target="_self">

			<b>Administration Pages Spellcheck</b>
				<table>
					<tr>
						<td width="5%"><input name="goosp_edit_post" type="checkbox" <?php checked(1,get_option('goosp_edit_post')) ?> value="1" /></td>
						<td width="95%"><label for="goosp_edit_post">Display on Post Editor</label></td>
					</tr>
					<tr>
						<td width="5%"><input name="goosp_edit_page" type="checkbox" <?php checked(1,get_option('goosp_edit_page')) ?> value="1" /></td>
						<td width="95%"><label for="goosp_edit_page">Display on Page Editor</label></td>
					</tr>
				</table>		

			<b>User Pages Spellcheck</b>
				<table>
					<tr>
						<td width="5%"><input name="goosp_edit_cmnt" type="checkbox" <?php checked(1,get_option('goosp_edit_cmnt')) ?> value="1" /></td>
						<td width="95%"><label for="goosp_edit_cmnt">Display on Comment Editor</label></td>
					</tr>
				</table>		

			<b>Select Languages for Menu</b>
				<?php $lang = get_option('goosp_lang_chkb'); ?>
				<table>
					<tr>
						<td width="5%"><input name="da_check" type="checkbox" <?php checked(1,$lang["da_check"]) ?> value="1" /></td>
						<td width="25%"><label for="da_check">Dansk</label></td>
						<td width="5%"><input name="de_check" type="checkbox" <?php checked(1,$lang["de_check"]) ?> value="1" /></td>
						<td width="25%"><label for="de_check">Deutsch</label></td>
						<td width="5%"><input name="en_check" type="checkbox" <?php checked(1,$lang["en_check"]) ?> value="1" /></td>
						<td width="35%"><label for="en_check">English</label></td>
					</tr>
					<tr>
						<td width="5%"><input name="es_check" type="checkbox" <?php checked(1,$lang["es_check"]) ?> value="1" /></td>
						<td width="25%"><label for="es_check">Espa&#241;ol</label></td>
						<td width="5%"><input name="fr_check" type="checkbox" <?php checked(1,$lang["fr_check"]) ?> value="1" /></td>
						<td width="25%"><label for="fr_check">Fran&#231;ais</label></td>
						<td width="5%"><input name="it_check" type="checkbox" <?php checked(1,$lang["it_check"]) ?> value="1" /></td>
						<td width="35%"><label for="it_check">Italiano</label></td>
					</tr>
					<tr>
						<td width="5%"><input name="nl_check" type="checkbox" <?php checked(1,$lang["nl_check"]) ?> value="1" /></td>
						<td width="25%"><label for="nl_check">Nederlands</label></td>
						<td width="5%"><input name="pl_check" type="checkbox" <?php checked(1,$lang["pl_check"]) ?> value="1" /></td>
						<td width="25%"><label for="pl_check">Polski</label></td>
						<td width="5%"><input name="pt_check" type="checkbox" <?php checked(1,$lang["pt_check"]) ?> value="1" /></td>
						<td width="35%"><label for="pt_check">Portugu&#234;s</label></td>
					</tr>
					<tr>
						<td width="5%"><input name="fi_check" type="checkbox" <?php checked(1,$lang["fi_check"]) ?> value="1" /></td>
						<td width="25%"><label for="fi_check">Suomi</label></td>
						<td width="5%"><input name="sv_check" type="checkbox" <?php checked(1,$lang["sv_check"]) ?> value="1" /></td>
						<td width="25%"><label for="sv_check">Svenska</label></td>
						<td width="5%"></td>
						<td width="35%"></td>
					</tr>
				</table>

			<b>G&ouml;SPress Display Options</b>
				<table>
					<tr>
						<td width="5%"><input name="goosp_disp_clos" type="checkbox" <?php checked(1,get_option('goosp_disp_clos')) ?> value="1" /></td>
						<td width="95%"><label for="goosp_disp_clos">Don't Display Close Buttons</label></td>
					</tr>
				</table>

			<p class="submit">
				<input name="submitted" type="hidden" value="yes" />
				<input type="submit" name="update_goosp" value="Update Options" />
			</p>
			
			</form>

		<p><i>For updates and support, please visit <a href="http://www.michael-gerard.com/creations/goospress/">Tossed Salad</a>.</i></p>

	</div>

<?php }


// INSERT OPTIONS PAGE SUBPANREL
function goosp_add_options_page(){
	add_options_page('G&ouml;SPress', 'G&ouml;SPress', 10, __FILE__, 'goosp_options_subpanel'); 	
}



// ACTIONS

	// ACTIVATE / DEACTIVATE PLUG
	add_action('activate_'.$goosp_url, array('goosp_installer','activate'));
	add_action('deactivate_'.$goosp_url, array('goosp_installer','deactivate'));
	
	// ADD ADMIN OPTIONS MENU
	add_action('admin_menu', 'goosp_add_options_page');
	
	// TEST FOR SPELL CHECK INSERTION (ADMIN AREAS)
	if(get_option('goosp_edit_post') ==  true || get_option('goosp_edit_page') == true){
		add_action('admin_head', array('goosp_injection','goosp_header'));
		
		if(get_option('goosp_edit_post') ==  true && get_option('goosp_edit_page') == false){
			add_action('edit_form_advanced', array('goosp_injection','goosp_admin_toolkit'));
		}elseif(get_option('goosp_edit_post') == false && get_option('goosp_edit_page') == true){
			add_action('edit_page_form', array('goosp_injection','goosp_admin_toolkit'));
		}elseif(get_option('goosp_edit_post') == true && get_option('goosp_edit_page') == true){
			add_action('edit_form_advanced', array('goosp_injection','goosp_admin_toolkit'));
			add_action('edit_page_form', array('goosp_injection','goosp_admin_toolkit'));
		}
	}
	
	// TEST FOR SPELL CHECK INSERTION (USER AREAS)
	if(get_option('goosp_edit_cmnt') == true){
		add_action('wp_head', array('goosp_injection','goosp_header'));
		add_action('comment_form', array('goosp_injection','goosp_cmmnt_toolkit'));
	}

?>